import 'dart:io';

import 'package:mustache/mustache.dart';

import '../response.dart';

class HtmlResponse extends Response {
  final String template;
  final HttpRequest request;
  final Map<String, dynamic> params;

  HtmlResponse(
    this.template,
    this.request, {
    this.params = {},
  });

  @override
  void output() {
    try {
      final contents = File(template + '.html').readAsStringSync();
      final templateF = Template(contents);

      try {
        final out = templateF.renderString(params);
      } catch (exc) {
        request.response
          ..statusCode = 500
          ..headers.contentType = ContentType('text', 'plain')
          ..writeln(
              'Internal server error 500. Could not parse and render template ${this.template}.html.')
          ..close();
      }

      request.response
        ..statusCode = 200
        ..headers.contentType = ContentType('text', 'html')
        ..writeln(out)
        ..close();
    } catch (exc) {
      request.response
        ..statusCode = 500
        ..headers.contentType = ContentType('text', 'plain')
        ..writeln('Internal Server Error 500. We are sorry.')
        ..close();
    }
  }
}
