import 'dart:io';

import '../response.dart';

class MethodNotAllowedResponse extends Response {
  final String body;
  final HttpRequest request;

  MethodNotAllowedResponse(
    this.body,
    this.request,
  );

  @override
  void output() {
    request.response
      ..headers.contentType = ContentType('text', 'plain')
      ..statusCode = HttpStatus.methodNotAllowed
      ..writeln(body)
      ..close();
  }
}
